Loading...
Searching...
No Matches
pcl::SIFTKeypoint< PointInT, PointOutT > Class Template Reference
Module keypoints

SIFTKeypoint detects the Scale Invariant Feature Transform keypoints for a given point cloud dataset containing points and intensity. More...

`#include <pcl/keypoints/sift_keypoint.h>`

Inheritance diagram for pcl::SIFTKeypoint< PointInT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< SIFTKeypoint< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const SIFTKeypoint< PointInT, PointOutT > >
using | PointCloudIn = typename Keypoint< PointInT, PointOutT >::PointCloudIn
using | PointCloudOut = typename Keypoint< PointInT, PointOutT >::PointCloudOut
using | KdTree = typename Keypoint< PointInT, PointOutT >::KdTree
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
using | Ptr = shared_ptr< Keypoint< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Keypoint< PointInT, PointOutT > >
using | BaseClass = PCLBase< PointInT >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(pcl::index_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, pcl::index_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| SIFTKeypoint ()
| Empty constructor.
void | setScales (float min_scale, int nr_octaves, int nr_scales_per_octave)
| Specify the range of scales over which to search for keypoints.
void | setMinimumContrast (float min_contrast)
| Provide a threshold to limit detection of keypoints without sufficient contrast.
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()=default
| Keypoint ()
| Empty constructor.
void | harrisCorner (PointInT &output, PointInT &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (PointInT &output, PointInT &input, const float sigma, bool SCALE)
void | hessianBlob (PointInT &output, PointInT &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (PointInT &output, PointInT &input1, PointInT &input2)
| ~Keypoint () override=default
| Empty destructor.
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for.
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used.
double | getSearchParameter ()
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection.
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors.
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
int | searchForNeighbors (pcl::index_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

bool | initCompute () override
void | detectKeypoints (PointCloudOut &output) override
| Detect the SIFT keypoints for a set of points given in setInputCloud () using the spatial locator in setSearchMethod ().
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name.
SearchMethod | search_method_
| The search method template for indices.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointOutT>
class pcl::SIFTKeypoint< PointInT, PointOutT >

SIFTKeypoint detects the Scale Invariant Feature Transform keypoints for a given point cloud dataset containing points and intensity.

This implementation adapts the original algorithm from images to point clouds.

For more information about the image-based SIFT interest operator, see:

David G. Lowe, "Distinctive image features from scale-invariant keypoints," International Journal of Computer Vision, 60, 2 (2004), pp. 91-110.

Author
  Michael Dixon

Definition at line 93 of file sift_keypoint.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT >

using pcl::SIFTKeypoint< PointInT, PointOutT >::ConstPtr = shared_ptr<const SIFTKeypoint<PointInT, PointOutT> >

Definition at line 97 of file sift_keypoint.h.

## KdTree

template<typename PointInT , typename PointOutT >

using pcl::SIFTKeypoint< PointInT, PointOutT >::KdTree = typename Keypoint<PointInT, PointOutT>::KdTree

Definition at line 101 of file sift_keypoint.h.

## PointCloudIn

template<typename PointInT , typename PointOutT >

using pcl::SIFTKeypoint< PointInT, PointOutT >::PointCloudIn = typename Keypoint<PointInT, PointOutT>::PointCloudIn

Definition at line 99 of file sift_keypoint.h.

## PointCloudOut

template<typename PointInT , typename PointOutT >

using pcl::SIFTKeypoint< PointInT, PointOutT >::PointCloudOut = typename Keypoint<PointInT, PointOutT>::PointCloudOut

Definition at line 100 of file sift_keypoint.h.

## Ptr

template<typename PointInT , typename PointOutT >

using pcl::SIFTKeypoint< PointInT, PointOutT >::Ptr = shared_ptr<SIFTKeypoint<PointInT, PointOutT> >

Definition at line 96 of file sift_keypoint.h.

## Constructor & Destructor Documentation

## SIFTKeypoint()

template<typename PointInT , typename PointOutT >

pcl::SIFTKeypoint< PointInT, PointOutT >::SIFTKeypoint | ( |  | ) |

inline

Empty constructor.

Definition at line 111 of file sift_keypoint.h.

References pcl::Keypoint< PointInT, PointOutT >::name_.

## Member Function Documentation

## detectKeypoints()

template<typename PointInT , typename PointOutT >

void pcl::SIFTKeypoint< PointInT, PointOutT >::detectKeypoints | ( | PointCloudOut & | output | ) |

override protected

Detect the SIFT keypoints for a set of points given in setInputCloud () using the spatial locator in setSearchMethod ().

Parameters

  output | the resultant cloud of keypoints

Definition at line 98 of file sift_keypoint.hpp.

References pcl::Filter< PointT >::filter(), pcl::PCLBase< PointT >::setInputCloud(), pcl::VoxelGrid< PointT >::setLeafSize(), and pcl::PointCloud< PointT >::size().

## initCompute()

template<typename PointInT , typename PointOutT >

bool pcl::SIFTKeypoint< PointInT, PointOutT >::initCompute | ( |  | ) |

override protected virtual

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 64 of file sift_keypoint.hpp.

## setMinimumContrast()

template<typename PointInT , typename PointOutT >

void pcl::SIFTKeypoint< PointInT, PointOutT >::setMinimumContrast | ( | float | min_contrast | ) |

Provide a threshold to limit detection of keypoints without sufficient contrast.

Parameters

  min_contrast | the minimum contrast required for detection

Definition at line 57 of file sift_keypoint.hpp.

## setScales()

template<typename PointInT , typename PointOutT >

void pcl::SIFTKeypoint< PointInT, PointOutT >::setScales | ( | float | min_scale,
|  | int | nr_octaves,
|  | int | nr_scales_per_octave
| ) |  |

Specify the range of scales over which to search for keypoints.

Parameters

  min_scale | the standard deviation of the smallest scale in the scale space
  nr_octaves | the number of octaves (i.e. doublings of scale) to compute
  nr_scales_per_octave | the number of scales to compute within each octave

Definition at line 47 of file sift_keypoint.hpp.

The documentation for this class was generated from the following files:

- pcl/keypoints/sift_keypoint.h
- pcl/keypoints/impl/sift_keypoint.hpp